## socnetv-3.2.tar.gz

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
#
# CMakeLists.txt - Build configuration for SocNetV (Social Network Visualizer)
#
# This file defines the build system for SocNetV, an open-source social network 
# analysis and visualization application built with Qt6. It is designed to support 
# cross-platform builds on Linux, macOS, and Windows. Below is an overview of its 
# key components and functionality:
#
# 1. **Project Setup**:
#    - Sets the project name, version, and description.
#    - Configures the C++17 standard as required.
#    - Includes `GNUInstallDirs` for standardized installation paths.
#
# 2. **Source and Resource Management**:
#    - Defines lists for source files, UI forms, and resources (e.g., icons).
#    - Automatically handles Qt-specific features like `AUTOMOC`, `AUTOUIC`, and `AUTORCC`.
#    - Copies the license file to the build directory during configuration.
#
# 3. **Platform-Specific Configurations**:
#    - Sets platform-specific binary names and properties:
#      - **Windows**: Configures the executable as a GUI application and embeds metadata.
#      - **macOS**: Creates a macOS app bundle with proper metadata, icons, and `PkgInfo`.
#      - **Linux**: Installs binaries, icons, desktop entry, man pages, and documentation 
#        to standard filesystem locations.
#
# 4. **Qt Integration**:
#    - Locates required Qt6 modules (e.g., Core, Widgets, OpenGLWidgets, Charts).
#    - Links the application with necessary Qt libraries.
#
# 5. **Compiler and Build Options**:
#    - Adds compiler warnings for GCC, Clang, and MSVC to ensure code quality.
#    - Configures include directories for header files.
#
# 6. **Installation and Packaging**:
#    - Defines installation rules for binaries, icons, desktop files, and documentation.
#    - Ensures compatibility with platform-specific installation standards.
#
# 7. **Debugging and Finalization**:
#    - Prints debug information during the configuration phase.
#    - Finalizes the Qt-specific setup for the executable.
#

cmake_minimum_required(VERSION 3.16) # 3.21 or 3.22 for better features and compatibility with modern tools.

# ==============================================================================
# 1. Project Setup
# ==============================================================================
# Set our project name and version:
set(APP_NAME SocNetV)
set(APP_NAME_LOWER socnetv)

project(SocNetV 
    VERSION 3.2
    DESCRIPTION "SocNetV: Open-source social network analysis application based on Qt."
    HOMEPAGE_URL "https://socnetv.org"
    LANGUAGES CXX
)

# Set the C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
# Some options here (UNUSED for now...):
option(DEV_MODE "Build in developer mode" OFF)


# Include GNUInstallDirs for standardized install locations
# Defines a set of variables for installation directories:
# CMAKE_INSTALL_PREFIX	Root directory for installation	/usr/local or C:/Program Files/<project>
# CMAKE_INSTALL_BINDIR	Directory for executable binaries	bin
# CMAKE_INSTALL_LIBDIR	Directory for libraries	lib or lib64
# CMAKE_INSTALL_INCLUDEDIR	Directory for header files	include
# CMAKE_INSTALL_DATAROOTDIR	Root directory for read-only data	share
# CMAKE_INSTALL_SYSCONFDIR	Directory for configuration files	etc
include(GNUInstallDirs)

# Define platform-specific binary names
if(WIN32)
    set(TARGET_NAME SocNetV)
elseif(APPLE)
    set(TARGET_NAME SocNetV)
else()
    set(TARGET_NAME socnetv)
endif()


# ==============================================================================
# 2. Source and Resource Management
# ==============================================================================
# Copy and rename our COPYING license file (Configure Time)

configure_file(${CMAKE_SOURCE_DIR}/COPYING
               ${CMAKE_BINARY_DIR}/LICENSE.txt
               COPYONLY)

# Define sources and headers
set (FORMS 
    src/forms/dialogfilteredgesbyweight.ui 
    src/forms/dialogfilternodesbycentrality.ui
    src/forms/dialogsettings.ui 
    src/forms/dialogsysteminfo.ui 
    src/forms/dialogwebcrawler.ui 
    src/forms/dialogdatasetselect.ui 
    src/forms/dialograndsmallworld.ui 
    src/forms/dialograndscalefree.ui 
    src/forms/dialogranderdosrenyi.ui 
    src/forms/dialograndregular.ui 
    src/forms/dialograndlattice.ui 
    src/forms/dialogsimilaritypearson.ui 
    src/forms/dialogsimilaritymatches.ui 
    src/forms/dialogdissimilarities.ui 
    src/forms/dialogclusteringhierarchical.ui   
    src/forms/dialognodeedit.ui 
    src/forms/dialognodefind.ui 
    src/forms/dialogedgedichotomization.ui 
    src/forms/dialogexportpdf.ui 
    src/forms/dialogexportimage.ui
    # Other UI files
)

set(SOURCES
    src/main.cpp 
    src/mainwindow.cpp 
    src/texteditor.cpp 
    src/graph.cpp 
    src/graphvertex.cpp 
    src/matrix.cpp 
    src/parser.cpp 
    src/webcrawler.cpp 
    src/chart.cpp 
    src/graphicswidget.cpp 
    src/graphicsedge.cpp 
    src/graphicsedgeweight.cpp 
    src/graphicsedgelabel.cpp 
    src/graphicsguide.cpp 
    src/graphicsnode.cpp 
    src/graphicsnodelabel.cpp 
    src/graphicsnodenumber.cpp 
    src/forms/dialogfilternodesbycentrality.cpp
    src/forms/dialogfilteredgesbyweight.cpp 
    src/forms/dialogedgedichotomization.cpp 
    src/forms/dialogwebcrawler.cpp 
    src/forms/dialogdatasetselect.cpp 
    src/forms/dialogpreviewfile.cpp 
    src/forms/dialognodeedit.cpp 
    src/forms/dialogranderdosrenyi.cpp 
    src/forms/dialograndsmallworld.cpp 
    src/forms/dialograndregular.cpp 
    src/forms/dialograndscalefree.cpp 
    src/forms/dialogsettings.cpp 
    src/forms/dialogsimilaritypearson.cpp 
    src/forms/dialogsimilaritymatches.cpp  
    src/forms/dialogdissimilarities.cpp 
    src/forms/dialogclusteringhierarchical.cpp  
    src/forms/dialograndlattice.cpp 
    src/forms/dialognodefind.cpp 
    src/forms/dialogexportpdf.cpp 
    src/forms/dialogexportimage.cpp 
    src/forms/dialogsysteminfo.cpp
    # Add remaining source files here
)


set(RESOURCES
    src/src.qrc
)


# List source files
message(STATUS "Source files to be compiled: ${SOURCES}")

# ==============================================================================
# 3. Platform-Specific Configurations
# ==============================================================================
# Set icons
set(ICON_FILE src/images/${APP_NAME_LOWER}.png)

if (APPLE)
    set(ICON_FILE src/images/${APP_NAME_LOWER}.icns)
endif()

if (WIN32)
    set(ICON_FILE src/images/${APP_NAME_LOWER}.ico)
endif()


# ==============================================================================
# 4. Qt Integration
# ==============================================================================
# Find Qt6
find_package(Qt6 REQUIRED COMPONENTS Core OpenGLWidgets Gui Core5Compat Widgets PrintSupport Network Charts Svg Xml)
# find_package_handle_standard_args(Qt6 DEFAULT_MSG Qt6_FOUND)

# Check if Qt6 was found
if (NOT Qt6_FOUND)
    message(FATAL_ERROR "Qt6 not found. Please install Qt6 and set the CMAKE_PREFIX_PATH.")
endif()

# The MANUAL_FINALIZATION option allows for additional 
# configuration before finalization
qt_add_executable(${TARGET_NAME} 
    MANUAL_FINALIZATION  
    ${SOURCES}
    ${FORMS}
    ${RESOURCES}
    ${ICON_FILE}
)

# Add include directories for headers (equivalent to INCLUDEPATH)
target_include_directories(${TARGET_NAME}  PUBLIC
                           "${CMAKE_SOURCE_DIR}/src"
                           )


# ==============================================================================
# 5. Compiler and Build Options
# ==============================================================================
# Set default target properties
set_target_properties(${TARGET_NAME} PROPERTIES
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED ON
    AUTOMOC ON
    AUTOUIC ON
    AUTORCC ON
)

# Add compiler options
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
    target_compile_options(${TARGET_NAME} PRIVATE -Wall -Wextra -Wpedantic)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(${TARGET_NAME} PRIVATE /W4)
endif()


# Link libraries
target_link_libraries(${TARGET_NAME} PRIVATE
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
    Qt6::OpenGLWidgets  
    Qt6::Core5Compat 
    Qt6::PrintSupport 
    Qt6::Network 
    Qt6::Charts 
    Qt6::Svg 
    Qt6::Xml
)



# ==============================================================================
# 6. Installation and Packaging
# ==============================================================================

# Add platform-specific properties
if(WIN32)

    # Add Windows-specific metadata and icon
    set_target_properties(${TARGET_NAME} PROPERTIES
        WIN32_EXECUTABLE TRUE
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION}
    )
    
    # Embed version and metadata into the binary using a resource file
    target_sources(${TARGET_NAME} PRIVATE src/icon.rc)

    # Optionally copy the target to a specific directory after build
    install(TARGETS ${TARGET_NAME}
        RUNTIME DESTINATION release/  # Install to release/ folder
    )

elseif(APPLE AND NOT IOS)
    set_source_files_properties("${CMAKE_SOURCE_DIR}/src/images/socnetv.icns" PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    target_sources(${TARGET_NAME} PRIVATE "${CMAKE_SOURCE_DIR}/src/images/socnetv.icns")

    set_target_properties(${TARGET_NAME} PROPERTIES
        MACOSX_BUNDLE TRUE
        MACOSX_BUNDLE_BUNDLE_NAME ${TARGET_NAME}
        MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
        MACOSX_BUNDLE_GUI_IDENTIFIER "org.socnetv.app"
        MACOSX_BUNDLE_COPYRIGHT "© 2024 Dimitris Kalamaras. Licensed under GNU GPL v3."
        MACOSX_BUNDLE_ICON_FILE "socnetv.icns"
    )

    # Ensure PkgInfo is explicitly created in the app bundle
    add_custom_command(TARGET ${TARGET_NAME} POST_BUILD
        COMMAND echo -n "APPL????" > "${CMAKE_BINARY_DIR}/${TARGET_NAME}.app/Contents/PkgInfo"
        COMMENT "🔍 Ensuring PkgInfo exists in the macOS app bundle"
    )

    # Install the main app bundle
    install(TARGETS ${TARGET_NAME}
        BUNDLE DESTINATION "${CMAKE_INSTALL_PREFIX}/Applications"
    )


elseif(LINUX)

    # Define the installation prefix (equivalent to qmake's PREFIX)
    # By default, this is /usr/local, but we set it to /usr for compatibility
    set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Installation prefix")

    # Set the installation paths and files
    install(TARGETS ${TARGET_NAME}
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"  # Binaries go to /usr/bin
#     LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
#     ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    )

    # Install the pixmap (icon file)
    install(FILES src/images/socnetv.png
        DESTINATION "${CMAKE_INSTALL_DATADIR}/pixmaps"
    )

    # Install the desktop entry file
    install(FILES socnetv.desktop
        DESTINATION "${CMAKE_INSTALL_DATADIR}/applications"
    )

    # Install the man page
    install(FILES man/socnetv.1
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1"
    )

    # Install the AppStream metadata file
    install(FILES socnetv.appdata.xml
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
    )

    # Install translations
    # install(FILES translations/socnetv_*.qm
    #     DESTINATION "${CMAKE_INSTALL_DATADIR}/socnetv"
    # )

    # Install documentation
    install(FILES CHANGELOG.md README.md TODO COPYING AUTHORS INSTALL
        DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/socnetv"
    )

endif()


# ==============================================================================
# 7. Debugging and Finalization
# ==============================================================================
# Print debug information

message(STATUS "Building ${PROJECT_NAME} (${TARGET_NAME}) ${PROJECT_VERSION}")
# NOTE: To develop/build in Visual Studio Code, do these steps:  
# 1. Install the extensions: Qt Extension Pack and CMake Tools 
# 2. Open Command Palette and select "Open User Settings".

=== debian/changelog ===
socnetv (3.2-1) focal; urgency=medium

  *  New upstream v3.2

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Tue, 01 Apr 2025 21:40:00 +0200

socnetv (3.1-1) bionic; urgency=medium

  *  New upstream v3.1

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Mon, 12 Jun 2023 13:40:00 +0200

socnetv (3.0.4-1) bionic; urgency=medium

  *  New upstream v3.0.4

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Fri, 30 Jul 2021 18:40:00 +0200

socnetv (3.0.3-1) bionic; urgency=medium

  *  New upstream v3.0.3

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Fri, 30 Jul 2021 18:36:00 +0200

socnetv (3.0.2-1) bionic; urgency=medium

  *  New upstream v3.0.2

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Fri, 30 Jul 2021 03:13:00 +0200

socnetv (3.0.1-1) bionic; urgency=medium

  *  New upstream v3.0.1

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Fri, 30 Jul 2021 00:13:00 +0200

socnetv (2.9-1) bionic; urgency=medium

  *  New upstream v2.9

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Mon, 14 Jun 2021 11:13:00 +0200

socnetv (2.8-1) xenial; urgency=medium
  
  *  New upstream v2.8

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Sun, 03 Jan 2021 17:44:00 +0200

socnetv (2.7-1) xenial; urgency=medium

  *  New upstream v2.7

 -- Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>  Mon, 28 Dec 2020 20:44:00 +0200

socnetv (2.6-2) xenial; urgency=medium

  *  New fixed upstream version 2.6. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Mon, 28 Dec 2020 18:44:00 +0200

socnetv (2.6-1) xenial; urgency=medium

  *  New upstream version 2.6. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Mon, 28 Dec 2020 13:44:00 +0200

socnetv (2.5-3) xenial; urgency=medium

  *  New upstream version 2.5. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Fri, 08 Mar 2019 11:59:14 +0200

socnetv (2.5-2) xenial; urgency=medium

  *  Fixed bug in debian package creation

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Wed, 20 Feb 2019 14:59:14 +0200

socnetv (2.5-1) xenial; urgency=medium

  * New upstream beta version 2.5-beta. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Tue, 19 Feb 2019 01:00:00 +0300

socnetv (2.4-2) xenial; urgency=medium

  * Fixed upstream version 2.4. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Wed, 28 Feb 2018 14:18:03 +0300

socnetv (2.4-1) xenial; urgency=medium

  * New upstream version 2.4. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Tue, 27 Feb 2018 21:18:03 +0300

socnetv (2.3-1) xenial; urgency=medium

  * New upstream version 2.3. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Wed, 05 Jul 2017 11:18:03 +0300

socnetv (2.2-1) xenial; urgency=medium

  * New upstream version 2.2. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Sat, 21 Jan 2017 22:13:03 +0300

socnetv (2.1-1) vivid; urgency=medium

  * New upstream version 2.1. See https://socnetv.org/ChangeLog  

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Wed, 28 Sep 2016 22:13:03 +0300

socnetv (2.0-4) vivid; urgency=medium

  * Version 2.0 patch for Ubuntu. 

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Tue, 13 Sep 2016 00:13:03 +0300

socnetv (2.0-3) trusty; urgency=medium

  * New upstream version 2.0. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Mon, 12 Sep 2016 22:13:03 +0300

socnetv (1.9-3) trusty; urgency=medium

  * New upstream version 1.9. See https://socnetv.org/ChangeLog 

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Tue, 23 Jun 2015 17:13:03 +0300

socnetv (1.8-3) trusty; urgency=medium

  * New upstream version. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Fri, 05 Jun 2015 16:13:03 +0300

socnetv (1.7-3) trusty; urgency=medium

  * New upstream version. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Wed, 20 May 2015 16:13:03 +0300

socnetv (1.6-3) trusty; urgency=medium

  * Build to fix upload in ubuntu archive 

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Mon, 11 May 2015 19:17:03 +0300

socnetv (1.6-1) trusty; urgency=medium

  * New upstream version. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Mon, 11 May 2015 14:12:55 +0300

socnetv (1.5-3) trusty; urgency=medium

  * New upstream version. See https://socnetv.org/ChangeLog

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Fri, 10 Oct 2014 15:14:34 +0300

socnetv (1.4-3) trusty; urgency=medium

  * upped rev for launchpad to accept package

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Mon, 01 Sep 2014 20:14:34 +0300

socnetv (1.4-1) trusty; urgency=medium

  * Sync to new upstream version

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Sat, 30 Aug 2014 18:06:23 +0300

socnetv (1.3-1) trusty; urgency=medium

  * Sync to new upstream version 1.3
  * Supports multirelational networks.
  * Memory and speed optimization

 -- Dimitris V. Kalamaras <dimitris_kalamaras@yahoo.gr>  Wed, 27 Aug 2014 20:36:23 +0300

socnetv (1.2-1) trusty; urgency=medium

  * Update package to upstream version 1.2 which bring a lot of changes
  * A new "prominence indices" conceptualization based on Wasserman & Faust
  * SocNetV distinguishes between Centrality and Prestige indices.
  * Added 3 Prestige indices (Degree, Proximity and PageRank)
  * New reachability measures (Walks, Connectedness, and Reachability Matrix) 
  * New Connectedness statistic: Checks whether the graph is connected.
  * New "distance" index: Eccentricity e


=== debian/control ===
Source: socnetv
Section: math
Priority: optional
Maintainer: Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>
XSBC-Original-Maintainer: Dimitris V. Kalamaras <dimitris.kalamaras@gmail.com>
Build-Depends: debhelper-compat (= 12),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-charts-dev,
               qt6-svg-dev,
               qt6-5compat-dev,
               libqt6opengl6-dev

Standards-Version: 4.5.1
Homepage: https://socnetv.org
Vcs-Git: https://github.com/socnetv/app.git 
Vcs-Browser: https://github.com/socnetv/app/tree/master/

Package: socnetv
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Social Networks Analysis and Visualization software
 SocNetV (Social Network Visualiser) is a flexible and
 user-friendly tool for Social Networks Analysis and Visualisation.
 It lets you create new networks (graphs) with a few clicks on a
 virtual canvas or load networks of various formats (GraphML, 
 GraphViz, Adjacency, UCINET, Pajek, etc) and modify them to suit 
 your needs.
 .
 The application can compute network properties, such as density,
 diameter and geodesic distances, as well as node-wise and network 
 indices such as various types of Centrality and Prestige. 
 Various layout algorithms (i.e. Spring-embedder, circular and in
 levels according to prominence indices) are supported for 
 meaningful visualisations of your networks. Furthermore, it can
 create various random networks (Erdos-Renyi, Watts-Strogatz, 
 ring lattice, etc) with a few clicks.
 .

=== debian/rules ===
#!/usr/bin/make -f

%:
	QT_SELECT=5 dh $@

override_dh_auto_configure:
	dh_auto_configure -- INSTALLS+=doc

override_dh_auto_install:
	$(MAKE) INSTALL_ROOT=$$(pwd)/debian/socnetv install
